#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <string.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "lcd_h.h"

#define SETB(reg,bit)	reg|=1<<bit
#define CLRB(reg,bit)	reg&=~(1<<bit)
#define NEGB(reg,bit)	reg^=1<<bit

#define Tlac1	bit_is_clear(PINB,PB0)
#define Tlac2	bit_is_clear(PINB,PB1)
#define Tlac3	bit_is_clear(PIND,PD6)
#define Tlac4	bit_is_clear(PIND,PD7)

#define LED1OFF		SETB(PORTB,PB2)
#define LED2OFF		SETB(PORTB,PB4)
#define LED3OFF		SETB(PORTD,PD3)
#define LED4OFF		SETB(PORTD,PD4)
#define LED5OFF		SETB(PORTC,PC4)

#define LED1ON		CLRB(PORTB,PB2)
#define LED2ON		CLRB(PORTB,PB4)
#define LED3ON		CLRB(PORTD,PD3)
#define LED4ON		CLRB(PORTD,PD4)
#define LED5ON		CLRB(PORTC,PC4)

#define IRON		CLRB(PORTB,PB3)
#define IROFF		SETB(PORTB,PB3)
static volatile unsigned char lcd_buffer[20];
static volatile unsigned char inter=0;
static volatile unsigned char prerus=0;

void vyslat(uint32_t vyslane);
void nadisp(uint32_t vvv);
void pripraven(void);
void odeslano(void);

ISR( TIMER0_COMP_vect )
{
if (inter==0) 
	{
	inter=1;
	IRON;
	}
else 
	{
	inter=0;
	IROFF;
	}
}


ISR( TIMER1_COMPA_vect )
{
//zastavit citace
TCCR1B = 0b00001000;
TCCR0 = 0b00001000;
IROFF;
inter=0;
TCNT0 = 0;	
TCNT1 = 0;
prerus=0;
}

int main( void )
{
unsigned char i;
uint32_t vyslane0=0x5555AAAA;
uint32_t vyslane1=0x7a8b9cad;
uint32_t vyslane2=0x12345678;
uint32_t vyslane3=0x6a5b4c3d;

	DDRA = 0xFF;
	DDRB = 0b00011100;
	PORTB = 0b00011111;
	DDRC = 0x00;
	DDRD = 0b00011111;
	PORTC = 0x00;			
	PORTD = 0b11011111;		
//	PORTC = 0b00100000;


// nastaveni citace0 pro generovani 38kHz na pin OC0
	OCR0 = 131;
	TCCR0 = 0b00001000;
	TCNT0 = 0;

//	nastaveni citace1

	OCR1A = 656;
	TCCR1A = 0b00000000;
	TCCR1B = 0b00001000;
	TCNT1 = 0;
    TIMSK = _BV(OCIE0) | _BV(OCIE1A);
		
	IROFF;
	lcd_init();
	pripraven();
	sei();


while(1)
{
if (Tlac1) 
{
_delay_ms(50);
LED1ON;
/*
OCR0 = 131;
OCR1A = 1313;//8,4ms
TCCR1B = 0b00001011;
TCCR0 = 0b00001001;
prerus=1;
while(prerus==1);
IROFF;

OCR1A = 656;//4,2ms
TCCR1B = 0b00001011;
prerus=1;
while(prerus==1);
IROFF;

OCR1A = 82;//0,52ms
TCCR1B = 0b00001011;
TCCR0 = 0b00001001;
prerus=1;
while(prerus==1);
IROFF;

OCR1A = 82;
TCCR1B = 0b00001011; 
prerus=1;
while(prerus==1);
IROFF;

for (i=0;i<=33;i++)
{
OCR1A = 82;
TCCR1B = 0b00001011;
TCCR0 = 0b00001001; 
prerus=1;
while(prerus==1);
IROFF;

OCR1A = 257;//1,65ms//164;//1,05ms
TCCR1B = 0b00001011; 
prerus=1;
while(prerus==1);
IROFF;

}
*/
vyslat(vyslane0);
nadisp(vyslane0);
odeslano();
pripraven();

}
else LED1OFF;
if (Tlac2)
{
_delay_ms(50); 
LED2ON;
vyslat(vyslane1);
nadisp(vyslane1);
odeslano();
pripraven();
}
else LED2OFF;
if (Tlac3)
{ 
_delay_ms(50);
LED3ON;
vyslat(vyslane2);
nadisp(vyslane2);
odeslano();
vyslane2++;
pripraven();
}
else LED3OFF;
if (Tlac4)
{
_delay_ms(50); 
LED4ON;
vyslat(vyslane3);
nadisp(vyslane3);
odeslano();
pripraven();
}
else LED4OFF;
}


}

void vyslat(uint32_t vyslane)
{
uint8_t pocetbitu;
uint32_t kopie = vyslane;
uint32_t maska = 0x80000000;
uint32_t zprac;

//start vysilani---
OCR0 = 131;
OCR1A = 1313;//8,4ms
TCCR1B = 0b00001011;
TCCR0 = 0b00001001;
prerus=1;
while(prerus==1);
IROFF;

OCR1A = 656;//4,2ms
TCCR1B = 0b00001011;
prerus=1;
while(prerus==1);
IROFF;
//bit navc - byl ji naprogramovn v pijmai
	//vysli sekvenci pro 1
	OCR1A = 82;
	TCCR1B = 0b00001011;
	TCCR0 = 0b00001001; 
	prerus=1;
	while(prerus==1);
	IROFF;

	OCR1A = 257;//1,65ms//164;//1,05ms
	TCCR1B = 0b00001011; 
	prerus=1;
	while(prerus==1);
	IROFF;
//-----------------
zprac = kopie & maska;

for (pocetbitu=0;pocetbitu<=33;pocetbitu++)
{
	if (zprac == 0)
	{//vysli sekvenci pro 0
	OCR1A = 82;
	TCCR1B = 0b00001011;
	TCCR0 = 0b00001001; 
	prerus=1;
	while(prerus==1);
	IROFF;

	OCR1A = 82;//0,52ms
	TCCR1B = 0b00001011; 
	prerus=1;
	while(prerus==1);
	IROFF;
	}
	else
	{//vysli sekvenci pro 1
	OCR1A = 82;
	TCCR1B = 0b00001011;
	TCCR0 = 0b00001001; 
	prerus=1;
	while(prerus==1);
	IROFF;

	OCR1A = 257;//1,65ms//164;//1,05ms
	TCCR1B = 0b00001011; 
	prerus=1;
	while(prerus==1);
	IROFF;
	}
kopie=kopie<<1;
zprac = kopie & maska;
}
}

void nadisp(uint32_t vvv)
{
unsigned int vyslanL = vvv & 0x0000FFFF;
unsigned int vyslanH = (vvv & 0xFFFF0000)>>16;
lcd_gotoxy(0,1);
sprintf(lcd_buffer,"%x",vyslanH);
lcd_puts(lcd_buffer);
sprintf(lcd_buffer,"%x",vyslanL);
lcd_puts(lcd_buffer);
}

void pripraven(void)
{
	lcd_gotoxy(0,0);
	lcd_puts("Pripraven");
}

void odeslano(void)
{
	lcd_gotoxy(0,0);
	lcd_puts("Odeslano:");
	_delay_ms(500);
}

void smazradek0(void)
{
	lcd_gotoxy(0,0);
	lcd_puts("                ");
}
